local tabardlink = nil
local tabardlinkout = nil
local tabardchat = true
local version = GetAddOnMetadata("TabardChampion", "Version") 

local function print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff78TabardChampion:|r "..msg)
end

local function Debug(...)
	local s = "TabardChampion Debug:"
	for i=1,select("#", ...) do
		local x = select(i, ...)
		s = strjoin(" ",s,tostring(x))
	end
	DEFAULT_CHAT_FRAME:AddMessage(s)
end

local function settabard()
	return GetInventoryItemLink("player", GetInventorySlotInfo("TabardSlot"))
end

-- equip that ugly thing -.-
local function equiptabard(link)
	if link then
		EquipItemByName(link, GetInventorySlotInfo("TabardSlot"))
	end
end

-- retrun the id of an bag with a free slot
-- 0 if free slot InBackpack
-- nil if all bags are full
local function getFreeBag()
	local freeid, typeid
	for bagid = NUM_BAG_SLOTS, 0, -1 do
		freeid, typeid = GetContainerNumFreeSlots(bagid)
		if  freeid > 0 and typeid == 0 then
			return bagid
		end
	end
	return nil
end

-- and off with it, yeah!
local function removetabard()
	if tabardlink then
		ClearCursor()
		PickupInventoryItem(GetInventorySlotInfo("TabardSlot"))
		
		local freeid = getFreeBag()
		if freeid then
			if freeid == 0 then
				PutItemInBackpack()
			else
				PutItemInBag(freeid+19)
			end
			--unequip any tabard
			local currentequipped = GetInventoryItemLink("player", GetInventorySlotInfo("TabardSlot"))
		else
			print("can't remove tabard, inventory is full *cry*")
			ClearCursor()
		end
	end
end

local function createOptionPanel()
	local optionPanel = CreateFrame( "Frame", "TabardChampionPanel", UIParent );
	local title = optionPanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	local version = GetAddOnMetadata("TabardChampion","Version") or ""
	--"X-Curse-Packaged-Version"
	title:SetText("TabardChampion "..version)

	local subtitle = optionPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	subtitle:SetHeight(35)
	subtitle:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
	subtitle:SetPoint("RIGHT", optionPanel, -32, 0)
	subtitle:SetNonSpaceWrap(true)
	subtitle:SetJustifyH("LEFT")
	subtitle:SetJustifyV("TOP")

	subtitle:SetText("Equipp a tabart and hit set to save it for auto equipp. To clear click set without a tabart equippet.")
	
	local itext = optionPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	itext:SetHeight(35)
	itext:SetPoint("TOPLEFT", subtitle, "BOTTOMLEFT", 0, -8)
	itext:SetPoint("RIGHT", optionPanel, -32, 0)
	itext:SetNonSpaceWrap(true)
	itext:SetJustifyH("LEFT")
	itext:SetJustifyV("TOP")

	itext:SetText("|cffffd200Instance Tabart:|r".." "..(tabardlink or "non (auto remove)"))

	local inButton = CreateFrame("Button",nil,optionPanel, "UIPanelButtonTemplate")
	inButton:SetWidth(100)
	inButton:SetHeight(22)
	inButton:SetScript("OnClick", function()
		TabardChampion_Tabard = settabard()
		tabardlink = TabardChampion_Tabard
		itext:SetText("|cffffd200Instance Tabart:|r".." "..(tabardlink or "non (auto remove)"))
	end)
	inButton:SetText("Set Current")
	inButton:SetPoint("TOPLEFT",itext,0,-18)
	
	local ntext = optionPanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	ntext:SetHeight(35)
	ntext:SetPoint("TOPLEFT", inButton, "BOTTOMLEFT", 0, -28)
	ntext:SetPoint("RIGHT", optionPanel, -82, 0)
	ntext:SetNonSpaceWrap(true)
	ntext:SetJustifyH("LEFT")
	ntext:SetJustifyV("TOP")

	ntext:SetText("|cffffd200Normal Tabart:|r".."  "..(tabardlinkout or "non (auto remove)"))
	
	local outButton = CreateFrame("Button",nil,optionPanel, "UIPanelButtonTemplate")
	outButton:SetWidth(100)
	outButton:SetHeight(22)
	outButton:SetScript("OnClick", function()
		TabardChampion_TabardOut = settabard()
		tabardlinkout = TabardChampion_TabardOut
		ntext:SetText("|cffffd200Normal Tabart:|r".."  "..(tabardlinkout or "non (auto remove)"))
	end)
	outButton:SetText("Set Current")
	outButton:SetPoint("TOPLEFT",ntext,0,-18)
	
	optionPanel.name = "TabardChampion";
	InterfaceOptions_AddCategory(optionPanel);
end

local function enteringWorld()
	--Debug(event);
	if event == "PLAYER_ENTERING_WORLD" then
		if not UnitIsDeadOrGhost("Player") then 
			local inini, initype = IsInInstance() 
			if initype == "party" then
				--Debug("equiptabard");
				equiptabard(tabardlink)
			else
				if tabardlinkout then
					equiptabard(tabardlinkout)
				else
				    --Debug("removetabard");
					removetabard()
				end
			end
		end
	else --VARIABLES_LOADED event
		tabardlink = TabardChampion_Tabard
		tabardlinkout = TabardChampion_TabardOut
		tabardchat = TabardChampion_Chat
		createOptionPanel()
	end
end



local function slashHandler(msg)
	InterfaceOptionsFrame_OpenToCategory("TabardChampion");
end

SlashCmdList["TabardChampion"] = slashHandler;
SLASH_TabardChampion1 = "/tabardchampion";
SLASH_TabardChampion2 = "/tc";

local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("VARIABLES_LOADED")
frame:SetScript("OnEvent", enteringWorld)